<?php
// Caching
include TEMPLATEPATH . '/functions/caching.php';
// Comment functions
include_once TEMPLATEPATH . '/functions/comments.php';
// Advanced excerpt
include_once TEMPLATEPATH . '/functions/excerpt.php';
// Pagination
include_once TEMPLATEPATH . '/functions/pagination.php';
// Widgets
include_once TEMPLATEPATH . '/functions/widgets.php';
// Monkpanel
include_once TEMPLATEPATH . '/functions/monkpanel/functions.php';

add_theme_support('post-thumbnails');
set_post_thumbnail_size(240, 88, true);
add_image_size('thumbnail-big', 240, 103, true);
add_image_size('thumbnail-feat', 563, 235, true);

add_theme_support('automatic-feed-links'); // Add default posts and comments RSS feed links to head

if (function_exists('register_nav_menu')) {
    register_nav_menu('fh_header', 'Farahim Menu');
}

/*
 *  Registering the widgetizable sidebar
 */

if (function_exists('register_sidebar')) {
    $sidebar_array = array('before_widget' => '<div class="widget"><div class="widget_btm"><div class="widget_cont">',
                           'after_widget' => '</div></div></div>',
                           'before_title' => '<h2 class="widgettitle cufon">',
                           'after_title' => '</h2>',
    );
    register_sidebar($sidebar_array);
}
/*
 *  Loading each JS-file
 */

function load_scripts_and_wp_head_action_hook()
{
    wp_enqueue_script('jquery');
    wp_enqueue_script('jqueryuicustom', get_bloginfo('template_directory') . '/js/custom.min.js', array('jquery'));
    wp_enqueue_script('cufon', get_bloginfo('template_directory') . '/js/cufon-1.10.min.js', array('jquery'));
    wp_enqueue_script('fhMain', get_bloginfo('template_directory') . '/js/main.js', array('jquery'));
    wp_enqueue_script('paginator', get_bloginfo('template_directory') . '/js/paginator3000.js', array('jquery'));
    wp_head();
}

/*
 *  Defining a new excerpt length
 */

function new_excerpt_length($length)
{
    return 30;
}

add_filter('excerpt_length', 'new_excerpt_length');

/*
 *  Defining a new excerpt 'more'-message
 */

function new_excerpt_more($more)
{
    return str_replace('[...]', '...', $more);
}

add_filter('excerpt_more', 'new_excerpt_more');

/* * * * * * * * * * *
 * Custom functions. *
 * * * * * * * * * * */

function all_posts_btn()
{
    $link = get_all_posts_link(); //get_pagelink_by_title('[all posts]');
    if ($link)
        echo "<a class='all_posts_btn' href='$link'>ادامه مطلب</a>";
}

function comments_balloon()
{
    echo '<a class="comments_balloon" href="' . get_permalink() . '# نظرات">' . get_comments_number('0', '1', '%') . '</a>';
}

function  featured_posts_slider()
{
    if (!function_exists('featured_posts'))
        return;

    $yafpp_opts = get_option('yafpp_opts');
    $has_featured_posts = $yafpp_opts['featured_posts'];
    if (!$has_featured_posts)
        return;

    $class_colour = get_option('fh_featured_color');
    echo "<div id='featured_posts_slider' class='$class_colour'>";
    featured_posts();
    echo '</div>';
    if ($yafpp_opts['get_featured_posts'])
        return get_featured_posts_array_of_ids();
}

function get_child_categories($id)
{
    global $wpdb;
    $sql = "SELECT term_id as id, name, slug FROM $wpdb->prefix" . "terms where term_id in (SELECT term_id FROM $wpdb->prefix" . "term_taxonomy where parent = $id and taxonomy = 'category')  order by name asc";
    $children = $wpdb->get_results($sql);
    return $children;
}

function get_parent_categories()
{

    global $wpdb;
    $sql = "SELECT term_id as id, name, slug FROM $wpdb->prefix" . "terms where term_id in (SELECT term_id FROM $wpdb->prefix" . "term_taxonomy where parent = 0 and taxonomy = 'category' and term_id != 1) order by name asc";
    $parents = $wpdb->get_results($sql);
    return $parents;
}

function get_the_date_time()
{
    if (get_option('fh_isUkTime')) {
        return 'y/m/d';
    } else {
        return 'y/m/d';
    }
}

function get_pagelink_by_title($page_title)
{
    global $wpdb;
    $page = $wpdb->get_var($wpdb->prepare("SELECT ID FROM $wpdb->posts WHERE post_title = %s AND post_type='page'", $page_title));
    if ($page)
        return get_page_link($page);
    return null;
}

function get_all_posts_link()
{
    global $wpdb;
    $sql = "SELECT id FROM $wpdb->prefix" . "postmeta, $wpdb->prefix" . "posts where post_id = id AND meta_value = 'template-allposts.php' AND post_status != 'trash' LIMIT 0, 1 ";
    $page = $wpdb->get_results($sql);
    $page_id = $page[0]->id;
    if ($page_id)
        return get_page_link($page_id);
    return null;
}

function get_the_post_thumbnail_url($type_thumb)
{
    $image_id = get_post_thumbnail_id();
    $image_url = wp_get_attachment_image_src($image_id, $type_thumb, true);
    return $image_url[0];
}

/*
 * creating a tinyurl based on a give url
 */

function get_tiny_url($url)
{
    return file_get_contents("http://tinyurl.com/api-create.php?url=" . $url);
}

function is_the_social_widget_integrated()
{
    return get_option('fh_withTwitter');
}

function monk_navigation()
{
    global $wp_query;
    if (function_exists('wp_paginator')) {
        wp_paginator();
    } else {
        if ($wp_query->max_num_pages > 1) :
            echo '<div id="pagination">';
            monk_previous_posts('Newer Entries', 0, 'older btn'); // older btn
            monk_next_posts('Older Entries', 0, 'newer btn'); //newer btn
            echo '</div>';
        endif;
    }
}

function monk_next_posts($label = 'Next Page', $max_page = 0, $class = '')
{
    global $paged;
    if ((!is_single()) && ($paged > 1)) {
        echo '<a  class="' . $class . '" href="';
        previous_posts();
        echo '">' . preg_replace('/&([^#])(?![a-z]{1,8};)/', '&#038;$1', $label) . '</a>';
    }
}

function monk_previous_posts($label = 'Previous Page', $max_page = 0, $class = '')
{
    global $paged, $wp_query;
    if (!$max_page) {
        $max_page = $wp_query->max_num_pages;

        if ((!is_single()) && (empty($paged) || $nextpage <= $max_page)) {
            echo '<a  class="' . $class . '" href="';
            next_posts($max_page);
            echo '">' . preg_replace('/&([^#])(?![a-z]{1,8};)/', '&#038;$1', $label) . '</a>';
        }
    }
}

function the_post_thumb($is_big_thumbnail = false)
{
    global $post;

    if (!has_post_thumbnail())
        return;
    $the_permalink = get_permalink();
    if ($is_big_thumbnail) {
        echo "<div class='thumb_cont big'>";
    }
    else {
        echo "<div class='thumb_cont'>";
    }
    echo "<a href='$the_permalink' class='thumb'>";
    if ($is_big_thumbnail) {
        the_post_thumbnail('thumbnail-big');
    }
    else {
        the_post_thumbnail();
    }
    echo "<span class='hidden'>&nbsp;</span>";
    echo "</a>";
    comments_balloon();
    echo "</div>";
}

function the_search()
{
    echo '<div id="search" class="' . get_option('fh_search_color') . '">';
    get_search_form();
    echo '</div>';
}

function text_trim($text, $max_char)
{
    if (strlen($text) > $max_char) {
        $text = substr($text, 0, $max_char - 3) . '';
    }
    return $text;
}

function with_or_without_social_widget_class()
{
    if (is_the_social_widget_integrated()) {
        return ' with_social_widget';
    } else {
        return '';
    }
}

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * 'Your'-functions are functions, which depend on your settings in the monkpanel. *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * /

/*
 * some predefined CSS options in the monk panel
 */

function your_css()
{
    $monk_css .= 'a{color:' . get_option('fh_colors_a') . '}';
    $monk_css .= 'a:hover{color:' . get_option('fh_colors_a_hover') . '}';
    $monk_css .= 'body{background-color:' . get_option('fh_colors_body') . '}';
    $monk_css .= '#footer_bg{background-color:' . get_option('fh_colors_footer') . '}';
    $monk_css .= get_option('fh_custom_css');

    echo strlen($monk_css) > 0 ? '<style type="text/css">' . addslashes($monk_css) . "</style>" : '';
}

function your_facebook_fans()
{
    try {
        $caching = new FacebookCaching('http://graph.facebook.com/' . your_facebook_page_id());
        echo $caching;
    } catch (Exception $e) {
        echo $e->getMessage();
    }
}

function your_facebook_page_id()
{
    return get_option('fh_fbPageID');
}

function your_facebook_page_url()
{
    echo get_option('fh_fbPageURL');
}

/*
 * get the feedcount based on the feedburner account
 */

function your_feed_count()
{
    if (!get_option('fh_isFeedburner'))
        return '<p class="feedb">هیچ</p><span>اکانت فید برنر</span>';

    try {
        $feedburner_account = get_option('fh_fbId');
        $caching = new FeedBurnerCaching($feedburner_account);
        return $caching . ' <span>عضو در فید برنر</span>';
    } catch (Exception $e) {
        return $e->getMessage();
    }
}

/*
 * get the feed based on a feedburner account or if none is set, the default Wordpress RSS
 */

function your_feed_URL()
{
    return get_option('fh_isFeedburner') ? 'http://feeds.feedburner.com/' . get_option('fh_fbId')
            : get_option('fh_rssLink');
}

function your_footer()
{
    echo stripslashes(get_option('fh_footer_text'));
}

/*
 * This will add your google analytics code to the theme.
 */

function your_google_analytics_code()
{
    echo stripslashes(get_option('fh_ga_code'));
}

/* The header widget with 2 options:
 * 1) show advertisement banner
 * 2) social icons
 */

function your_header_widget()
{
    if (get_option('fh_adv')) {
        ?>
    <div id="adv_468">
        <a href="<?php echo get_option('fh_adv_link') ?>" rel="external">
            <img src="<?php echo get_option('fh_adv_img') ?>" alt="advertisement" /> <span class="hidden">&nbsp;</span>
        </a>
    </div>
    <?php } else { ?>
    <div class="share">
        <ul>
            <li>
                <a href="http://www.stumbleupon.com/submit?url=<?php echo urlencode(get_option('home')); ?>" rel="external" class="stumbleupon">stumbleupon</a>
            </li>
            <li>
                <a href="http://www.technorati.com/faves?add=<?php echo urlencode(get_option('home')); ?>" rel="external" class="technorati">technorati</a>
            </li>
            <li>
                <a href="http://twitter.com/home?status=<?php bloginfo('name') ?> - <?php bloginfo('description'); ?> (<?php echo get_tiny_url(get_option('home')); ?>)" rel="external" class="twitter">twitter</a>
            </li>
            <li>
                <a href="http://del.icio.us/post?url=<?php echo urlencode(get_option('home')); ?>" rel="external" class="delicious">delicious</a>
            </li>
            <li>
                <a href="http://www.facebook.com/share.php?u=<?php echo urlencode(get_option('home')); ?>" rel="external" class="facebook">facebook</a>
            </li>
            <li>
                <a href="http://digg.com/submit?phase=2&amp;url=<?php echo urlencode(get_option('home')); ?>&amp;title=<?php urlencode(bloginfo('name')); ?>-<?php urlencode(bloginfo('description')); ?>" rel="external" class="digg">digg</a>
            </li>
        </ul>
    </div>
    <?php

    }
}

/*
 * Prints out your logo
 */

function your_logo()
{
    echo '<img src="' . get_option('fh_logo') . '" alt="' . get_bloginfo('name') . ' - Home" />';
}

function your_sub_header()
{

    your_rss();
    if (is_the_social_widget_integrated()) {
        include_once 'includes/social_widget.inc.php';
    }
    the_search();
}

/*
 * Prints out your navigation
 */

function your_navigation()
{
    echo '<div id="navigation" class="' . get_option('fh_nav_color') . '">';
    echo '<a class="home" href="' . get_option('home') . '">خانه</a>';
        wp_nav_menu(array(fallback_cb => false, 'container' => false, 'menu_id' => 'nav', 'menu_class' => false, 'sort_column' => 'menu_order', 'title_li' => '', 'link_before' => '<span>', 'link_after' => '</span>', 'depth' => 3, 'theme_location' => 'fh_header'));
    echo '</div>';
}

/*
 * Prints out your RSS
 */

function your_rss()
{
    echo '<div id="rss" class="' . get_option('fh_rss_color') . '">';
    echo '<a href="' . your_feed_URL() . '">' . your_feed_count() . '</a>';
    echo  '</div>';
}

function your_twitter_followers()
{
    try {
        $caching = new TwitterCaching(get_your_twitter_username());
        echo $caching;
    } catch (Exception $e) {
        echo $e->getMessage();
    }
}

function get_your_twitter_username()
{
    return get_option('fh_twId');
}

function your_twitter_page_url()
{
    $twitter_username = get_your_twitter_username();
    echo "http://twitter.com/$twitter_username";
}
function custom_excerpt_more($more) {
return '';
}
add_filter('excerpt_more', 'custom_excerpt_more');
add_filter('excerpt_length', 'new_excerpt_length');
function excerpt($limit) {
  $excerpt = explode(' ', get_the_excerpt(), $limit);
  if (count($excerpt)>=$limit) {
    array_pop($excerpt);
	
    $excerpt = implode(" ",$excerpt). '...';
	
  } else {
    $excerpt = implode(" ",$excerpt);
  }	
  $excerpt = preg_replace('`\[[^\]]*\]`','',$excerpt);
  
  return $excerpt;
  
}
function dt_content_limit($max_char, $more_link_text = '', $stripteaser = 0, $more_file = '') {
    $content = get_the_content($more_link_text, $stripteaser, $more_file);
    $content = apply_filters('the_content', $content);
    $content = str_replace(']]>', ']]&gt;', $content);
    $content = strip_tags($content);

   if (strlen($_GET['p']) > 0) {
      echo "";
      echo $content;
      echo "...";
   }
   else if ((strlen($content)>$max_char) && ($espacio = strpos($content, " ", $max_char ))) {
        $content = substr($content, 0, $espacio);
        $content = $content;
        echo "";
        echo $content;
        echo "...";
   }
   else {
      echo "";
      echo $content;
   }
}
function ODD_title($max_char, $more_link_text = '', $stripteaser = 0, $more_file = '') {
    $title = get_the_title($post->ID);
    $title = apply_filters('the_title', $title);
    $title = str_replace(']]>', ']]&gt;', $title);
    $title = strip_tags($title);

   if (strlen($_GET['p']) > 0) {
      echo "";
      echo $title;
      echo "...";
   }
   else if ((strlen($title)>$max_char) && ($espacio = strpos($title, " ", $max_char ))) {
        $title = substr($title, 0, $espacio);
        $title = $title;
        echo "";
        echo $title;
        echo "...";
   }
   else {
      echo "";
      echo $title;
   }
}